import 'dart:async';

import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:feed_plugin/bloc/feed_cubit.dart';
import 'package:feed_plugin/pages/home_page.dart';
import 'package:feed_plugin/repo/feed_repository.dart';
import 'package:feed_plugin/service/http_service.dart';

class FeedPlugin {
  static Widget feed_plugin(
      {@required String token,
      @required String firstName,
      @required String lastName,
      @required String about,
      @required String profileImg,
      String partnerToken,
      @required String partnerCompanyName,
      @required String logo,
      @required media}) {
    Widget app() {
      return MaterialApp(
        home: HomePage(
          token: token,
          firstName: firstName,
          lastName: lastName,
          about: about,
          profileImg: profileImg,
          partnerMedia: media,
          partnerName: partnerCompanyName,
          partnerToken: partnerToken,
          partnerProfileImg: logo,
        ),
        routes: <String, WidgetBuilder>{
          '/homePage': (BuildContext context) => new HomePage(
                token: token,
                firstName: firstName,
                lastName: lastName,
                about: about,
                profileImg: profileImg,
                partnerMedia: media,
                partnerName: partnerCompanyName,
                partnerToken: partnerToken,
                partnerProfileImg: logo,
              )
        },
      );
    }

    final httpService = HttpService("gogog");
    final feedRepository = FeedRepository(httpService);
    final feedCubit = FeedCubit(feedRepository: feedRepository);
    runApp(
      MultiRepositoryProvider(
        providers: [
          RepositoryProvider<FeedRepository>(
            create: (context) => FeedRepository(httpService),
          )
        ],
        child: MultiBlocProvider(providers: [
          BlocProvider<FeedCubit>(
            create: (context) {
              return feedCubit;
            },
          ),
        ], child: app()),
      ),
    );
    return Text("", textDirection: TextDirection.ltr);
  }
}
